package cviceni10.model;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */



import java.io.Serializable;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;

/**
 *
 * @author nav79
 */
@Entity
@Table(name="katedry",
uniqueConstraints={@UniqueConstraint(name="cislonazev",
                                     columnNames={"cislo","nazev"})})
@NamedQueries(
   value={@NamedQuery(name="Katedra.findCislo",
                      query="select k from Katedra k where k.cisloKatedry=:ck"),
          @NamedQuery(name="Katedra.findByVedouci",
                      query="select k from Katedra k where k.vedouci.login=:vedouci"),
          @NamedQuery(name="Katedra.findAll",
                      query="select k from Katedra k")})
public class Katedra implements Serializable {
    private List<Osoba> clenove;
    private static final long serialVersionUID = 1L;
    private Long id;
    private int cisloKatedry;
    private String nazev;
    private Osoba vedouci;

    @OneToOne(cascade=CascadeType.ALL)
    public Osoba getVedouci() {
        return vedouci;
    }

    public void setVedouci(Osoba vedouci) {
        this.vedouci = vedouci;
    }


    @Column(name="cislo",nullable=false,unique=true)
    public int getCisloKatedry() {
        return cisloKatedry;
    }

    public void setCisloKatedry(int cisloKatedry) {
        this.cisloKatedry = cisloKatedry;
    }

    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getNazev() {
        return nazev;
    }

    public void setNazev(String nazev) {
        this.nazev = nazev;
    }


    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Katedra other = (Katedra) obj;
        if (this.cisloKatedry != other.cisloKatedry) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 17 * hash + this.cisloKatedry;
        return hash;
    }

    @OneToMany(mappedBy = "katedra")
    public List<Osoba> getClenove() {
        return clenove;
    }

    public void setClenove(List<Osoba> clenove) {
        this.clenove = clenove;
    }
}
